#ifndef _ARITH_16
#define _ARITH_16

#define ADD_r16_rm16 \
DecodeModRM; \
Read_rm16(op2_16); \
op1_16=Read_Reg16(Regop); \
aux16=op1_16+op2_16; \
Write_Reg16(Regop,aux16); \
if (Is_CF(aux16,op1_16)) SetCF; \
if (Is_AF(aux16,op1_16,op2_16)) SetAF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define ADD_rm16_r16 \
DecodeModRM; \
Read_rm16(op1_16); \
op2_16=Read_Reg16(Regop); \
aux16=op1_16+op2_16; \
Write_rm16(aux16); \
if (Is_CF(aux16,op1_16)) SetCF; \
if (Is_AF(aux16,op1_16,op2_16)) SetAF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define ADD_rm16_imm16 \
Read_rm16(op1_16); \
op2_16=CPUReadMemory16(); \
aux16=op1_16+op2_16; \
Write_rm16(aux16); \
if (Is_CF(aux16,op1_16)) SetCF; \
if (Is_AF(aux16,op1_16,op2_16)) SetAF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define ADD_rm16_imm8 \
Read_rm16(op1_16); \
op2_8=CPUReadMemory8(); \
aux16=op1_16+op2_8; \
Write_rm16(aux16); \
if (Is_CF(aux16,op1_16)) SetCF; \
if (Is_AF(aux16,op1_16,op2_8)) SetAF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define ADD_AX_imm16 \
op2_16=CPUReadMemory16(); \
aux16=AX+op2_16; \
if (Is_CF(aux16,AX)) SetCF; \
if (Is_AF(aux16,AX,op2_16)) SetAF; \
if (Is_SF16(aux16)) SetSF; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF; \
AX=aux16 \

#define SUB_r16_rm16 \
DecodeModRM; \
Read_rm16(op2_16); \
op1_16=Read_Reg16(Regop); \
aux16=op1_16-op2_16; \
Write_Reg16(Regop,aux16); \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define SUB_rm16_r16 \
DecodeModRM; \
Read_rm16(op1_16); \
op2_16=Read_Reg16(Regop); \
aux16=op1_16-op2_16; \
Write_rm16(aux16); \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define SUB_rm16_imm16 \
Read_rm16(op1_16); \
op2_16=CPUReadMemory16(); \
aux16=op1_16-op2_16; \
Write_rm16(aux16); \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define SUB_rm16_imm8 \
Read_rm16(op1_16); \
op2_8=CPUReadMemory8(); \
aux16=op1_16-op2_8; \
Write_rm16(aux16); \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define SUB_AX_imm16 \
op2_16=CPUReadMemory16(); \
aux16=AX-op2_16; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF; \
AX=aux16 \

#define NEG_rm16 \
Read_rm16(op1_16); \
aux16=-op1_16; \
Write_rm16(aux16) \

#define INC_rm16 \
Read_rm16(op1_16); \
aux16=op1_16+1; \
Write_rm16(aux16); \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define DEC_rm16 \
Read_rm16(op1_16); \
aux16=op1_16-1; \
Write_rm16(aux16); \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define INC_r16(R) \
aux16=R+1; \
R=aux16; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#define DEC_r16(R) \
aux16=R-1; \
R=aux16; \
if (Is_ZF(aux16)) SetZF; \
if (Is_PF(aux16)) SetPF \

#endif
