#ifndef _ARITH_8
#define _ARITH_8

#define ADD_r8_rm8 \
DecodeModRM; \
Read_rm8(op2_8); \
op1_8=Read_Reg8(Regop); \
aux8=op1_8+op2_8; \
Write_Reg8(Regop,aux8); \
if (Is_CF(aux8,op1_8)) SetCF; \
if (Is_AF(aux8,op1_8,op2_8)) SetAF; \
if (Is_SF8(aux8)) SetSF; \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF \

#define ADD_rm8_r8 \
DecodeModRM; \
Read_rm8(op1_8); \
op2_8=Read_Reg8(Regop); \
aux8=op1_8+op2_8; \
Write_rm8(aux8); \
if (Is_CF(aux8,op1_8)) SetCF; \
if (Is_AF(aux8,op1_8,op2_8)) SetAF; \
if (Is_SF8(aux8)) SetSF; \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF \

#define ADD_rm8_imm8 \
Read_rm8(op1_8); \
op2_8=CPUReadMemory8(); \
aux8=op1_8+op2_8; \
Write_rm8(aux8); \
if (Is_CF(aux8,op1_8)) SetCF; \
if (Is_AF(aux8,op1_8,op2_8)) SetAF; \
if (Is_SF8(aux8)) SetSF; \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF \

#define ADD_AL_imm8 \
op2_8=CPUReadMemory8(); \
aux8=AL+op2_8; \
if (Is_CF(aux8,AL)) SetCF; \
if (Is_AF(aux8,AL,op2_8)) SetAF; \
if (Is_SF8(aux8)) SetSF; \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF; \
AL=aux8 \

#define SUB_r8_rm8 \
DecodeModRM; \
Read_rm8(op2_8); \
op1_8=Read_Reg8(Regop); \
aux8=op1_8-op2_8; \
Write_Reg8(Regop,aux8); \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF \

#define SUB_rm8_r8 \
DecodeModRM; \
Read_rm8(op1_8); \
op2_8=Read_Reg8(Regop); \
aux8=op1_8-op2_8; \
Write_rm8(aux8); \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF \

#define SUB_rm8_imm8 \
Read_rm8(op1_8); \
op2_8=CPUReadMemory8(); \
aux8=op1_8-op2_8; \
Write_rm8(aux8); \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF \

#define SUB_AL_imm8 \
op2_8=CPUReadMemory8(); \
aux8=AL-op2_8; \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF; \
AL=aux8 \

#define NEG_rm8 \
Read_rm8(op1_8); \
aux8=-op1_8; \
Write_rm8(aux8) \

#define INC_rm8 \
Read_rm8(op1_8); \
aux8=op1_8+1; \
Write_rm8(aux8); \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF \

#define DEC_rm8 \
Read_rm8(op1_8); \
aux8=op1_8-1; \
Write_rm8(aux8); \
if (Is_ZF(aux8)) SetZF; \
if (Is_PF(aux8)) SetPF \

#endif
